<template>
  <div id="main_map">

    <div class="cell cell-map">
      
        <div style="height: 100%; width: 100%">
          <l-map
            ref="map"
            v-if="showMap"
            :zoom="zoom"
            :center="center"
            :options="mapOptions"
            style="height: 100%"
            @update:center="centerUpdate"
            @update:zoom="zoomUpdate"
          >
            <l-draw-toolbar position="topleft"/>
            <l-control-layers position="topright" :collapsed="controlCollapsed" ></l-control-layers>
            <l-ruler :options="rulerOptions" />
            <v-tilelayer-googlemutant 
                name="google" 
                visible=false
                apikey="AIzaSyCe7aTRCps2fFQEoyHv0QQ0dTEe-y5kk1M" lang="YOUR_LANG" region="YOUR_REGION" 
                :options="googlemutantoptionsobject">
            </v-tilelayer-googlemutant>
            <l-tile-layer
                v-for="tileProvider in tileProviders"
                :key="tileProvider.name"
                :name="tileProvider.name"
                :visible="tileProvider.visible"
                :url="tileProvider.url"
                :attribution="tileProvider.attribution"
                layer-type="base"/>



            <l-layer-group 
              visible=true
              layerType="overlay"
              name="Objects">

            </l-layer-group>
            <l-layer-group 
                :visible="sourceVisible"
                layerType="overlay"
                name="BETEX">
                  <v-marker-cluster :options="{foo: 'bar'}">
                  <l-marker v-for="point in points" 
                      :lat-lng="point.geo" :key="point.name" :radius="15" 
                      :draggable="true"
                      :color="point.color">
                      <l-icon>
                        <div :style="point.style"  style="padding:5px; width:25pt; height:13pt; border-radius: 10px;"  v-if="showDetails">
                          {{ point.avg_p }} 
                        </div>
                        <div :style="point.style" style="width:10pt; height:10pt; border-radius: 5px;"  v-if="!showDetails">
                        </div>
                      </l-icon>

                    <!-- <l-tooltip :options="{
                        interactive: true,
                        permanent: true
                      }">
                      {{point.avg_p}}
                    </l-tooltip>
                    <l-popup>
                      <div>
                        Name:{{point.name}}<br>
                        Avg bezen:{{point.avg_p}}<br>
                      </div>
                    </l-popup> -->
                  </l-marker>
                  </v-marker-cluster>
            </l-layer-group>
          </l-map>
        </div>

    </div>
    <div class="cell cell-edit">
      <Edit :geojson="points" v-on:change="points = $event"></Edit>
    </div>
    <div class="cell cell-inspect">
        <div style="overflow: auto;">
          <p>First marker is placed at {{ withPopup.lat }}, {{ withPopup.lng }}</p>
          <p>Center is at {{ currentCenter }} and the zoom is: {{ currentZoom }}</p>
          <button @click="showLongText">
            Toggle long popup
          </button>
          <button @click="showDetails = !showDetails">
            Toggle details
          </button>
        </div>
      <!-- <MapContainer :geojson="stations" v-on:select="selected = $event"></MapContainer> -->
    </div>


  </div>
</template>

<script>
  import Feature from 'ol/Feature'
  import { latLng } from "leaflet";
  import { LMap, LTileLayer, LMarker, LIcon, LControlLayers, LLayerGroup} from "vue2-leaflet";
  import LDrawToolbar from 'vue2-leaflet-draw-toolbar';
  // import MapContainer from '../components/MapContainer';
  import Edit from '../components/Edit';
  import LRuler from "vue2-leaflet-ruler";
  import Vue2LeafletMarkerCluster from 'vue2-leaflet-markercluster'
  import Vue2LeafletGoogleMutant from 'vue2-leaflet-googlemutant'
  import axios from 'axios';


  export default {
    name: 'Inspect',
    components: {
      LMap,
      LTileLayer,
      // LCircleMarker,
      // LPopup,
      // LTooltip,
      LLayerGroup,
      LMarker,
      LIcon,
      LControlLayers,
      LDrawToolbar,
      // MapContainer,
      LRuler,
      'v-marker-cluster': Vue2LeafletMarkerCluster,
      'v-tilelayer-googlemutant': Vue2LeafletGoogleMutant,
      Edit
    },
    props: {
      feature: Feature
    },
    computed: {
      props() {
        return this.feature
          ? this.feature.getKeys().filter(key => key !== this.feature.getGeometryName())
          : []
      }
    },
    mounted(){


      // this.$nextTick(() => {
      //   const map = this.$refs.map.mapObject;
      //   const drawControl = new window.L.Control.Draw({
      //     position: 'topright',
      //     draw: {
      //       polyline: {
      //         allowIntersection: false,
      //         showArea: true
      //       },
      //       polygon: false,
      //       rectangle: false,
      //       circle: false,
      //       marker: false
      //     }
      //   });

      //   map.addControl(drawControl);

      //   const editableLayers = new window.L.FeatureGroup().addTo(map);
      //   map.on(window.L.Draw.Event.CREATED, (e) => {
      //     // const type = e.layerType;
      //     const layer = e.layer;

      //     // Do whatever else you need to. (save to db, add to map etc)
      //     editableLayers.addLayer(layer);
      //   });
      // });

        function getColor(d) {
                return d > 1.5 ? '#800026' :
                      d > 1.3  ? '#BD0026' :
                      d > 1  ? '#E31A1C' :
                      d > 0.8  ? '#FC4E2A' :
                      d > 0.5  ? '#FD8D3C' :
                      d > 0.3  ? '#FEB24C' :
                      d > 0.1   ? '#FED976' :
                                  '#FFEDA0';
        }

        axios
          .get('./benzen_1.csv')
          .then(response => {
            let objs = [];
            let lines = response.data.split("\n");
            lines.forEach(line=>{
                let columns = line.split(",");
                console.log(columns[0]);
                let avg = parseFloat(columns[7]);
                let color = "#ff0000";
                color = getColor(avg);
                // if(avg>0.5){
                //   color = "#00ff00";
                // }
                // if(avg>1){
                //   color = "#0000ff";
                // }
                // if(avg>1.5){
                //   color = "#ff00ff";
                // }
                objs.push({
                  name:columns[0],
                  geo: [parseFloat(columns[1]), parseFloat(columns[2])],
                  avg_p:parseFloat(columns[7]),
                  color:color,
                  style:"background-color:"+color+"; "
                });
                })
            // let pp  = response.data.csvToArray();
            // var data = Papa.parse(response.data);
            // console.log(response);
            this.points = objs;
          })
    },
  data() {
    return {
      controlCollapsed:false,
      circle: {
        center: latLng(47.41322, -1.0482),
        radius: 100
      },
      sourceVisible:true,
      zoom: 6,
      center: latLng(47.58657, 16.978266),
      url1: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
      url: 'https://{s}.tile.opentopomap.org/{z}/{x}/{y}.png', 
      attribution:
        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      withPopup: latLng(47.41322, -1.219482),
      withTooltip: latLng(47.41422, -1.250482),
      currentZoom: 11.5,
      currentCenter: latLng(47.41322, -1.219482),
      showDetails: false,
      mapOptions: {
        zoomSnap: 0.5,
        maxZoom: 22,
      },
      tileProviders: [
        {
          name: 'OpenStreetMap',
          visible: true,
          attribution:
            '&copy; <a target="_blank" href="http://osm.org/copyright">OpenStreetMap</a> contributors',
          url: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
        },
        {
          name: 'OpenTopoMap',
          visible: false,
          url: 'https://{s}.tile.opentopomap.org/{z}/{x}/{y}.png',
          attribution:
            'Map data: &copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>, <a href="http://viewfinderpanoramas.org">SRTM</a> | Map style: &copy; <a href="https://opentopomap.org">OpenTopoMap</a> (<a href="https://creativecommons.org/licenses/by-sa/3.0/">CC-BY-SA</a>)',
        },
      ],
      googlemutantoptionsobject:{
        type: "hybrid", // valid values are 'roadmap', 'satellite', 'terrain' and 'hybrid'
      },
      rulerOptions: {
        position: "topright", // Leaflet control position option
        circleMarker: {
          // Leaflet circle marker options for points used in this plugin
          color: "red",
          radius: 2,
        },
        lineStyle: {
          // Leaflet polyline options for lines used in this plugin
          color: "red",
          dashArray: "1,6",
        },
        lengthUnit: {
          // You can use custom length units. Default unit is kilometers.
          display: "km", // This is the display value will be shown on the screen. Example: 'meters'
          decimal: 2, // Distance result will be fixed to this value.
          factor: null, // This value will be used to convert from kilometers. Example: 1000 (from kilometers to meters)
          label: "Distance:",
        },
        angleUnit: {
          display: "&deg;", // This is the display value will be shown on the screen. Example: 'Gradian'
          decimal: 2, // Bearing result will be fixed to this value.
          factor: null, // This option is required to customize angle unit. Specify solid angle value for angle unit. Example: 400 (for gradian).
          label: "Bearing:",
        },
      },



      showMap: true,
      points:[
            [38.770547, -90.168056],
            [38.753816, -90.177326],
            [38.747390, -90.183849],
            [38.731456, -90.206337],
            [38.719805, -90.212002],
            [38.706142, -90.210629],
            [38.692879, -90.202217],
            [38.680150, -90.189857],
            [38.665139, -90.182991],
            [38.646774, -90.179729],
            [38.630818, -90.179214],
            [38.615663, -90.183849],
            [38.601713, -90.190201],
            [38.587759, -90.204620],
            [38.577427, -90.219212],
            [38.564140, -90.232258],
            [38.545615, -90.248566],
            [38.531650, -90.257664],
            [38.538901, -90.270023],
            [38.548702, -90.273113],
            [38.561053, -90.294399],
            [38.574072, -90.309334],
            [38.596346, -90.320320],
            [38.614054, -90.314827],
            [38.632159, -90.304527],
            [38.651198, -90.302296],
            [38.664067, -90.293713],
            [38.683768, -90.278263],
            [38.700650, -90.265388],
            [38.717662, -90.253887],
            [38.722349, -90.238266],
            [38.729715, -90.221272],
            [38.742302, -90.203934],
            [38.754886, -90.191746],
            [38.764792, -90.184021],
            [38.771350, -90.183334]
      ],
      layers: [
          {
            id: 0,
            name: 'Restaurants',
            active: false,
            features: [ /* snip */ ],
          },
          {
            id: 1,
            name: 'City/County Boundaries',
            active: false,
            features: [],
          },
        ],
    };
  },
  methods: {
    zoomUpdate(zoom) {
      this.currentZoom = zoom;
    },
    centerUpdate(center) {
      this.currentCenter = center;
    },
    showLongText() {
      this.showParagraph = !this.showParagraph;
    },
    innerClick() {
      alert("Click!");
    }
  }


  }
</script>

<style scoped>
@import "~leaflet.markercluster/dist/MarkerCluster.css";
@import "~leaflet.markercluster/dist/MarkerCluster.Default.css";

  #main_map {
    font-family: Avenir, Helvetica, Arial, sans-serif;
    height: 100%;
    display: grid;
    grid-template-columns: 100vh;
    grid-auto-rows: 1fr;
    grid-gap: 1rem;
    padding: 1rem;
    box-sizing: border-box;
  }
  .cell {
    border-radius: 4px;
    background-color: lightgrey;
  }
  .cell-map {
    grid-column: 1;
    grid-row-start: 1;
    grid-row-end: 3;
  }
  .cell-edit {
    grid-column: 2;
    grid-row: 1;
  }
  .cell-inspect {
    grid-column: 2;
    grid-row: 2;
  }
</style>